using Microsoft.AspNetCore.Authorization;
using Microsoft.AspNetCore.Mvc;
using Microsoft.AspNetCore.Mvc.RazorPages;
using Serilog;
using WorkFlowCheck.Common.DTO;
using WorkFlowCheck.Web.Services.Interfaces;

namespace WorkFlowCheck.Web.Pages.BaseStock.CheckPoints
{
    [Authorize]
    [ValidateAntiForgeryToken]
    public class CheckPointEditPageModel : PageModel
    {
        private readonly ILogger<IndexModel> _logger;
        private readonly IBaseStockService _baseStockService;

        [BindProperty]
        public CheckPointDTO CheckPointDTO { get; set; }

        public CheckPointEditPageModel(ILogger<IndexModel> logger, IBaseStockService baseStockService)
        {
            _baseStockService = baseStockService;
            _logger = logger;
        }
        public async Task OnGet(int id)
        {
            CheckPointDTO = await _baseStockService.GetCheckPoint(id);

        }
        public async Task<JsonResult> OnGetLoadCheckListTemplateRows(int id)
        {
            CheckPointDTO = await _baseStockService.GetCheckPoint(id);
            return new JsonResult(new { data = CheckPointDTO.CheckListTemplateRowDTO });
        }

        public async Task<IActionResult> OnPostSave([FromBody] CheckPointDTO checkPointDTO)
        {
            try
            {
                var result = await _baseStockService.UpdateCheckPoint(checkPointDTO);
                if (result.IsSuccess)
                {
                    return new JsonResult(new { success = true });
                }
                else
                {
                    return new JsonResult(new { success = false });
                }
            }
            catch (Exception ex)
            {
                Log.Error(ex.Message);
            }

            return new JsonResult(new { success = false });
        }
    }
}
